<?php
if ( ! defined( 'ABSPATH' ) ) {
  exit; // Exit if accessed directly
}
global $item_id, $item, $order;
$id = $item['product_id'];

$we_adress = get_post_meta( $id, 'we_adress', true );
$we_startdate = get_post_meta( $id, 'we_startdate', true );
$image_src = wp_get_attachment_image_src( get_post_thumbnail_id($id),'wethumb_460x307' );
$ftk = 0;
ob_start();
?>
<script type="text/javascript">
  function exprintcontent(layer){
    var gennerator = window.open(",'name,");
    var layertext= document.getElementById(layer);
    gennerator.document.write(layertext.innerHTML.replace('Print Me'));
    gennerator.document.close();
    gennerator.print();
    gennerator.close();

  }
</script>
<a href="javascript:;" class="we-print-tk" style="font-size: 15px;" onclick="javascript:exprintcontent('printJS-form-food')">
  <i class="fa fa-print" style="margin-right: 5px"></i><?php echo esc_html__('Print Ticket','exthemes'); ?>
</a>
<style>
  #printJS-form-food{visibility:hidden;height: 0}
</style>
<div  id="printJS-form-food">
  <style type="text/css" media="print">
      @page 
      {
          size: auto;
          margin: 0mm;
      }
      body{ margin: 40px; }
  </style>
  <style type="text/css">
    .wetk-ginfo > div{ width: 47%; display: inline-block; vertical-align: middle;}
    .wetk-ginfo > div img{ max-width: 100% }
    .wetk-ginfo > .wetk-details{ padding: 15px; }
    .wetk-ginfo > .wetk-details span{ display: block; }
    .wetk-ginfo > .wetk-details > div{ margin-bottom: 15px; }
    .wetk-info { margin-top: 40px; }
    .wetk-info h3{ margin-bottom: 30px; }
    .wetk-info table tr th{ background:#fbfbfb}
    .wetk-info table{border: 1px solid #ddd;margin: 0;padding: 0; width: 100%; text-align: left;}
    .wetk-info table tr td,
    .wetk-info table tr th {
        border: 0;
        border-bottom: 1px solid #ddd;
        border-right: 1px solid #ddd;
        padding: 15px 20px;
    }
    .wetk-info table tr td:last-child,
    .wetk-info table tr th:last-child{border-right: 0;}
    .wetk-info table tr:last-child td{ border-bottom:0}
    .wetk-info .we-tk-foodter { width: 100%; text-align: center; margin: 30px; }
  </style> 
  <div class="wetk-ginfo">
    <div class="wetk-image">
      <img src="<?php if(isset($image_src[0]) && $image_src[0]!=''){ echo esc_url($image_src[0]);}?>">
    </div>
    <div class="wetk-details">
      <div class="wetk-name">
        <h3><?php echo get_the_title( $id ); ?></h3>  
        <hr/>
      </div>
      <?php if($we_startdate!=''){?> 
        <div class="wetk-date">
          <strong><?php esc_html_e('Date','wp-food');?></strong>
          <span><?php echo date_i18n( get_option('date_format'), $we_startdate).' - '.date_i18n(get_option('time_format'), $we_startdate);?></span>
        </div>
      <?php } if($we_adress!=''){?>
        <div class="wetk-loc">
          <strong><?php esc_html_e('Location','wp-food');?></strong>
          <span><?php echo $we_adress;?></span>
        </div>
      <?php }?>
    </div>
  </div>
  <div class="wetk-info">
    <div>
      <h3><?php echo get_option('we_text_attende_')!='' ? get_option('we_text_attende_') : esc_html__('Attendees info','exthemes');?></h3>
      <?php 
      $order_items = $order->get_items();
      $n = 0; $find = 0;
      foreach ($order_items as $items_key => $items_value) {
        $n ++;
        if($items_value->get_id() == $item_id){
          $find = 1;
          break;
        }
      }
      if($find == 0){ return;}
      if($item['variation_id']!='' && $item['variation_id'] > 0){
        $id = $item['variation_id'];
      }
      $value_id = $id.'-'.$n;
      $tk_sr = $order->get_id().'-'.$value_id;
      $tickets_info = get_post_meta($order->get_id(),'ticket_info-'.$tk_sr, false);
      $total_quantity = $order->get_item_count();
      if(!empty($tickets_info)){
        $ftk = 1;
        $i = 0;
        ?>
        <table>
            <thead>
              <tr>
                <th></th>
                <th><?php esc_html_e('Name','exthemes');?></th>
                <th><?php esc_html_e('Email','exthemes');?></th>
                <th><?php esc_html_e('Ticket number','exthemes');?></th>
              </tr>
            </thead>
            <tbody>
            <?php
            foreach ($tickets_info as $ticket => $info) {
              $i ++;
              if($i>$total_quantity){ break;}
              $info = explode("|",$info);
              $f_name = isset($info[1]) && $info[1]!='' ? $info[1] : '';
              $l_name = isset($info[2]) && $info[2]!='' ? $info[2] : '';
              ?>
                  <tr>
                    <td><?php echo $i;?></td>
                    <td><?php echo  $f_name!='' && $l_name!='' ? '<span>'.$f_name.' '.$l_name.'</span>' : '';?></td>
                    <td><?php echo isset($info[0]) && $info[0]!='' ? $info[0] : '';?></td>
                    <td><?php echo $tk_sr.'-'.$info[3];?></td>
                  </tr>
              <?php    
            }
            ?>
          </tbody>
        </table>
        <?php
      }

      ?>
      <div class="we-tk-foodter">
        <strong><?php echo apply_filters( 'we_footer_ticket_text',get_bloginfo().' - Powered by WooEvents');?></strong>
      </div>
    </div>
  </div>
</div>
<?php
$output_string = ob_get_contents();
ob_end_clean();
if($ftk==1){
  echo $output_string;
}