<?php
global $columns,$number_excerpt,$show_time,$orderby,$img_size;
$we_startdate = get_post_meta( get_the_ID(), 'we_startdate', true );
$we_enddate = get_post_meta( get_the_ID(), 'we_enddate', true )  ;
global $product;	
$type = $product->get_type();
$price ='';
if($type=='variable'){
	$price = we_variable_price_html();
}else{
	if ( $price_html = $product->get_price_html() ) :
		$price = $price_html; 
	endif; 	
}
if(get_post_type(get_the_ID()) == 'product_variation') {
	$variation = wc_get_product(get_the_ID());
	$parent_id = $variation->get_parent_id();
}else{ $parent_id = get_the_ID();}
$we_adress = get_post_meta( $parent_id, 'we_adress', true );
$we_status = woo_event_status( get_the_ID(), $we_enddate);
if(get_option('we_dis_status') =='yes'){ $we_status ='';}
$we_eventcolor = we_event_custom_color(get_the_ID());
if($we_eventcolor==''){$we_eventcolor = we_autochange_color();}
$bgev_color = '';
if($we_eventcolor!=""){
	$bgev_color = 'style="background-color:'.esc_attr($we_eventcolor).'"';
}
$html_baget = we_badget_html();
?>
<div class="item-post-n">
	<figure class="ex-modern-blog">
		<div class="image <?php if($html_baget!=''){ echo 'gr-withbg';}?>">
			<a href="<?php echo get_permalink(get_the_ID()); ?>" class="link-more">
				<?php echo get_the_post_thumbnail($parent_id,$img_size);?>
                <?php if($we_startdate!=''){?>
				<div class="shop-we-stdate" <?php echo exwe_dataes($bgev_color);?>><span class="day"><?php echo date_i18n( 'd', $we_startdate); ?></span><span class="month"><?php echo date_i18n('M', $we_startdate); ?></span></div>
                <?php }?>
            </a>
            <?php echo exwe_dataes($html_baget);?>  
		</div>
		<div class="grid-content">
			<figcaption>
				<?php we_event_label_html();?>
				<h3><a href="<?php echo get_permalink(get_the_ID()); ?>" class="link-more">
					<?php  the_title(); ?>
                </a><?php we_subtitle_html($parent_id);?></h3>
				<div class="shop-we-more-meta">
				<?php
					if($we_startdate!=''){
						$st_d = date_i18n( 'd', $we_startdate);
						$st_m = date_i18n( 'F', $we_startdate);
						$sttime = '';
						if($show_time=='1'){
							$sttime = ' - '.date_i18n(get_option('time_format'), $we_startdate);
						}
						echo '<span><i class="fa fa-calendar"></i>'.date_i18n( get_option('date_format'), $we_startdate).$sttime.'</span>';
					}
					if($we_enddate!=''){
						$e_d = date_i18n( 'd', $we_enddate);
						$e_m = date_i18n( 'F', $we_enddate);
						if( ($st_d != $e_d) || ($st_m != $e_m) ){
	                        $edtime = '';
	                        if($show_time=='1'){
	                            $edtime = ' - '.date_i18n(get_option('time_format'), $we_enddate);
	                        }
	                        echo '<span class="we-ed-gr"><i class="fa fa-calendar-times-o"></i>'.date_i18n( get_option('date_format'), $we_enddate).$edtime.'</span>';
	                    }
                    }
					if($price!=''){
						echo  '<span><i class="fa fa-shopping-basket"></i>'.$price.'</span>';
					}
					if($we_status!=''){
						echo '
						<span>
							<i class="fa fa-ticket"></i>
							'.$we_status.'
						</span>';
					}
				?>
				</div>
                <?php if($number_excerpt!='0'){?>
				<div class="grid-excerpt"><?php echo wp_trim_words(get_the_excerpt($parent_id),$number_excerpt,$more = '...');?></div>
                <?php }?>
                <a class="exwt-btn exwt-btn exwt-btn-primary we-button" <?php echo exwe_dataes($bgev_color);?> href="<?php echo get_permalink(get_the_ID());?>">
					<?php echo get_option('we_text_viewdetails')!='' ? get_option('we_text_viewdetails') : esc_html__('View Details','exthemes');?>
                </a>
                <?php do_action( 'we_after_grid_content_html' );?>
                <div class="clear"></div>
			</figcaption>
		</div>
        
	</figure>    
</div>